 using CP;
 
 int NbPacients = ...;
 int NbMedicals = ...;
 int NbRooms = ...;
 
 range RPacients = 1..NbPacients;
 range RMedicals = 1..NbMedicals;
 range RRooms = 1..NbRooms;
 
 tuple Tmedical{
  int duration;
  {int} rooms;
}
 
 Tmedical Medicals[RMedicals] = ...;
 
 tuple pMedical{
  int pacient; 
  int medical;
}
 {pMedical} PMedicals = ...;
 
 tuple Tprec{
 int before;
 int after; 
 }
 {Tprec} Prec = ...;
 
 int Priorities[RPacients] = ...;
 
 dvar interval times[pm in PMedicals] size Medicals[pm.medical].duration;
 
 dvar sequence seqPacient[p in RPacients] in all(pm in PMedicals: pm.pacient == p) times[pm];
 
 dvar interval assigned[PMedicals][RRooms] optional;
 
 dexpr int pacientMax[p in RPacients] = max (pm in PMedicals: pm.pacient == p) endOf(times[pm]);
 minimize sum (p in RPacients) Priorities[p]*pacientMax[p];
 
 subject to {
 
 forall (pr in Prec, pmB in PMedicals, pmA in PMedicals:
          pmB.pacient == pmA.pacient && pmB.medical == pr.before && pmA.medical == pr.after)
          endBeforeStart(times[pmB],times[pmA]);
 
 forall (p in RPacients) noOverlap(seqPacient[p]);
 
 forall (pm in PMedicals)
        alternative (times[pm], all (r in RRooms: r in Medicals[pm.medical].rooms) assigned[pm][r]); 
  
 forall (r in RRooms) 
        noOverlap(all (pm in PMedicals: r in Medicals[pm.medical].rooms) assigned[pm][r]); 
}
